package manage

import (
	"demo/configs"
	"demo/data/domain"
	"demo/data/domain/vo"
)

func GetGoodsSkuCardById(id int64) (domain.GoodsSkuCard, error) {
	var goodsSkuCard domain.GoodsSkuCard
	_, err := configs.Engine.Table("goods_sku_card").Where("id = ?", id).Get(&goodsSkuCard)
	if err != nil {
		return goodsSkuCard, err
	}
	return goodsSkuCard, nil
}

func GetGoodsSkuCardListInId(ids []int64) ([]domain.GoodsSkuCard, error) {
	rows, err := configs.Engine.Table("goods_sku_card").In("id", ids).Rows(&domain.GoodsSkuCard{})
	if err != nil {
		return make([]domain.GoodsSkuCard, 0), err
	}
	defer rows.Close()
	var list []domain.GoodsSkuCard
	for rows.Next() {
		var u domain.GoodsSkuCard
		rows.Scan(&u)
		list = append(list, u)
	}
	return list, nil
}

func GetGoodsSkuCardList(goodsSkuCard domain.GoodsSkuCard, pageNum, pageSize int) (vo.BaseListVo, error) {
	var arr []domain.GoodsSkuCard
	Count, err := configs.Engine.Table("goods_sku_card").Limit(pageSize, (pageNum-1)*pageSize).FindAndCount(&arr, &goodsSkuCard)
	var vo vo.BaseListVo
	if err != nil {
		return vo, err
	}
	if err != nil {
		return vo, err
	}
	vo.PageNum = pageNum
	vo.PageSize = pageSize
	vo.List = make([]any, len(arr))
	for i, v := range arr {
		vo.List[i] = v
	}
	vo.Total = int(Count)
	return vo, nil
}

func SaveGoodsSkuCard(goodsSkuCard *domain.GoodsSkuCard) (domain.GoodsSkuCard, error) {
	_, err := configs.Engine.Table("goods_sku_card").Insert(&goodsSkuCard)
	if err != nil {
		return *goodsSkuCard, err
	}
	return *goodsSkuCard, nil
}

func SetGoodsSkuCard(goodsSkuCardMap map[string]interface{}, id int64) (domain.GoodsSkuCard, bool, error) {
	var goodsSkuCard domain.GoodsSkuCard
	_, err := configs.Engine.Table("goods_sku_card").Where("id = ?", id).Update(goodsSkuCardMap)
	if err != nil {
		return goodsSkuCard, false, err
	}
	return goodsSkuCard, true, nil
}

func DeleteGoodsSkuCard(id int64) bool {
	var goodsSkuCard domain.GoodsSkuCard
	i, err := configs.Engine.Table("goods_sku_card").Where("id = ?", id).Delete(&goodsSkuCard)
	if err != nil {
		return false
	}
	return i > 0
}
